OGRE-Next: Ogre::v1::TextAreaOverlayElement Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | List of all members
Ogre::v1::TextAreaOverlayElement Class Reference
Core » Overlays

This class implements an overlay element which contains simple unformatted text. More...

`#include <OgreTextAreaOverlayElement.h>`

Inheritance diagram for Ogre::v1::TextAreaOverlayElement:
[legend]

## Classes
class | CmdAlignment
| Command object for setting the alignment. More...
class | CmdCaption
| Command object for setting the caption. More...
class | CmdCharHeight
| Command object for setting the char height. More...
class | CmdColour
| Command object for setting the constant colour. More...
class | CmdColourBottom
| Command object for setting the bottom colour. More...
class | CmdColourTop
| Command object for setting the top colour. More...
class | CmdFontName
| Command object for setting the caption. More...
class | CmdSpaceWidth
| Command object for setting the width of a space. More...

## Public Types
enum | Alignment { Left , Right , Center }
Public Types inherited from Ogre::Renderable
typedef map< size_t, Vector4 >::type | CustomParameterMap

## Public Member Functions
| TextAreaOverlayElement (const String &name)
| Constructor.
| ~TextAreaOverlayElement () override
void | _releaseManualHardwareResources () override
| Notifies that hardware resources were lost.
void | _restoreManualHardwareResources () override
| Notifies that hardware resources should be restored.
void | _update () override
| Overridden from OverlayElement.
Alignment | getAlignment () const
Real | getCharHeight () const
const ColourValue & | getColour () const override
| Gets the colour of the text.
const ColourValue & | getColourBottom () const
| Gets the colour of the bottom of the letters.
const ColourValue & | getColourTop () const
| Gets the colour of the top of the letters.
const String & | getFontName () const
const MaterialPtr & | getMaterial () const
| See Renderable.
void | getRenderOperation (v1::RenderOperation &op, bool casterPass) override
| See Renderable.
Real | getSpaceWidth () const
const String & | getTypeName () const override
| See OverlayElement.
void | initialise () override
| Initialise gui element.
void | setAlignment (Alignment a)
void | setCaption (const DisplayString &text) override
| Sets the caption on elements that support it.
void | setCharHeight (Real height)
void | setColour (const ColourValue &col) override
| Sets the colour of the text.
void | setColourBottom (const ColourValue &col)
| Sets the colour of the bottom of the letters.
void | setColourTop (const ColourValue &col)
| Sets the colour of the top of the letters.
void | setFontName (const String &font)
void | setMaterialName (const String &matName) override
| Overridden from OverlayElement.
void | setMetricsMode (GuiMetricsMode gmm) override
| Overridden from OverlayElement.
void | setSpaceWidth (Real width)
Public Member Functions inherited from Ogre::v1::OverlayElement
| OverlayElement (const String &name)
| Constructor: do not call direct, use OverlayManager::createElement.
| ~OverlayElement () override
virtual void | _getClippingRegion (RealRect &clippingRegion)
| Gets the clipping region of the element.
virtual Real | _getDerivedLeft ()
| Gets the 'left' position as derived from own left and that of parents.
virtual Real | _getDerivedTop ()
| Gets the 'top' position as derived from own left and that of parents.
Real | _getHeight () const
| Gets the height of this element in relation to the screen (where 1.0 = screen height)
Real | _getLeft () const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)
virtual Real | _getRelativeHeight ()
| Gets the 'height' as derived from own height and metrics mode.
virtual Real | _getRelativeWidth ()
| Gets the 'width' as derived from own width and metrics mode.
Real | _getTop () const
| Gets the top of this element in relation to the screen (where 0 = far left, 1.0 = far right)
Real | _getWidth () const
| Gets the width of this element in relation to the screen (where 1.0 = screen width)
virtual void | _notifyParent (OverlayContainer *parent, Overlay *overlay)
| Internal method for notifying the GUI element of it's parent and ultimate overlay.
virtual void | _notifyViewport ()
| Internal method to notify the element when the viewport of parent overlay has changed.
virtual void | _positionsOutOfDate ()
| Tell the object to recalculate.
void | _setDimensions (Real width, Real height)
| Sets the width and height of this element in relation to the screen (where 1.0 = screen width)
void | _setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen width)
void | _setLeft (Real left)
| Sets the left of this element in relation to the screen (where 1.0 = screen width)
void | _setParent (OverlayContainer *parent)
void | _setPosition (Real left, Real top)
| Sets the left and top of this element in relation to the screen (where 1.0 = screen width)
void | _setTop (Real top)
| Sets the top of this element in relation to the screen (where 1.0 = screen width)
void | _setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width)
virtual void | _updateFromParent ()
| Updates this elements transform based on it's parent.
virtual void | _updateRenderQueue (RenderQueue *queue, Camera *camera, const Camera *lodCamera)
| Internal method to put the contents onto the render queue.
virtual OverlayElement * | clone (const String &instanceName)
virtual bool | contains (Real x, Real y) const
| Returns true if xy is within the constraints of the component.
virtual void | copyFromTemplate (OverlayElement *templateOverlay)
virtual OverlayElement * | findElementAt (Real x, Real y)
| Returns true if xy is within the constraints of the component.
virtual const DisplayString & | getCaption () const
| Gets the caption for this element.
Real | getHeight () const
| Gets the height of this element in relation to the screen (where 1.0 = screen height)
virtual GuiHorizontalAlignment | getHorizontalAlignment () const
| Gets the horizontal alignment for this element.
Real | getLeft () const
| Gets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)
const LightList & | getLights () const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial () const
| See Renderable.
virtual const String & | getMaterialName () const
| Gets the name of the material this element uses.
virtual GuiMetricsMode | getMetricsMode () const
| Retrieves the current settings of how the element metrics are interpreted.
const String & | getName () const
| Gets the name of this overlay.
OverlayContainer * | getParent ()
| Returns the parent container.
const OverlayElement * | getSourceTemplate () const
| Returns the SourceTemplate for this element.
Real | getTop () const
| Gets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom)
virtual GuiVerticalAlignment | getVerticalAlignment () const
| Gets the vertical alignment for this element.
Real | getWidth () const
| Gets the width of this element in relation to the screen (where 1.0 = screen width)
void | getWorldTransforms (Matrix4 *xform) const override
| See Renderable.
virtual void | hide ()
| Hides this element if it was visible.
virtual bool | isCloneable () const
virtual bool | isContainer () const
| returns false as this class is not a container type
bool | isEnabled () const
virtual bool | isKeyEnabled () const
bool | isVisible () const
| Returns whether or not the element is visible.
virtual void | setCloneable (bool c)
void | setDimensions (Real width, Real height)
| Sets the dimensions of this element in relation to the screen (1.0 = screen width/height).
virtual void | setEnabled (bool b)
void | setHeight (Real height)
| Sets the height of this element in relation to the screen (where 1.0 = screen height)
virtual void | setHorizontalAlignment (GuiHorizontalAlignment gha)
| Sets the horizontal origin for this element.
void | setLeft (Real left)
| Sets the left of this element in relation to the screen (where 0 = far left, 1.0 = far right)
void | setPosition (Real left, Real top)
| Sets the position of the top-left corner of the element, relative to the screen size (1.0 = screen width / height)
void | setTop (Real Top)
| Sets the top of this element in relation to the screen (where 0 = top, 1.0 = bottom)
virtual void | setVerticalAlignment (GuiVerticalAlignment gva)
| Sets the vertical origin for this element.
void | setWidth (Real width)
| Sets the width of this element in relation to the screen (where 1.0 = screen width)
virtual void | show ()
| Shows this element if it was hidden.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
virtual void | _setHlmsHashes (uint32 hash, uint32 casterHash)
| Manually sets the hlms hashes. Don't call this directly.
virtual void | _setNullDatablock ()
| Sets the datablock to a null pointer.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters_AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
void | addPoseWeight (size_t index, float w)
virtual bool | getCastsShadows () const
| Method which reports whether this renderable would normally cast a shadow.
uint8 | getCurrentMaterialLod () const
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
const CustomParameterMap & | getCustomParameters () const
HlmsDatablock * | getDatablock () const
const String & | getDatablockOrMaterialName () const
uint32 | getHlmsCasterHash () const
uint32 | getHlmsHash () const
MaterialPtr | getMaterial () const
| Retrieves the material this renderable object uses.
unsigned short | getNumPoses () const
virtual unsigned short | getNumWorldTransforms () const
| Returns the number of world transform matrices this renderable requires.
virtual bool | getPolygonModeOverrideable () const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
bool | getPoseHalfPrecision () const
bool | getPoseNormals () const
TexBufferPacked * | getPoseTexBuffer () const
float | getPoseWeight (size_t index) const
float * | getPoseWeights () const
uint8 | getRenderQueueSubGroup () const
bool | getUseIdentityProjection () const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView () const
| Returns whether or not to use an 'identity' view.
virtual bool | getUseIdentityViewProjMatrixIsDynamic () const
| Returns whether the Hlms implementation should evaluate getUseIdentityProjection per object at runtime, or if it can assume the Renderable will remain with the same setting until the datablock is flushed (performance optimization)
virtual bool | getUseIdentityWorldMatrix () const
| Returns whether the world matrix is an identity matrix.
virtual OGRE_DEPRECATED const Any & | getUserAny () const
UserObjectBindings & | getUserObjectBindings ()
| Return an instance of user objects binding associated with this class.
const UserObjectBindings & | getUserObjectBindings () const
| Return an instance of user objects binding associated with this class.
const VertexArrayObjectArray & | getVaos (VertexPass vertexPass) const
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
bool | hasSkeletonAnimation () const
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
virtual bool | preRender (SceneManager *sm, RenderSystem *rsys)
| Called just prior to the Renderable being rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
virtual void | setDatablock (HlmsDatablock *datablock)
| Assigns a datablock (i.e. HLMS Material) to this renderable.
void | setDatablock (IdString datablockName)
| Assigns a datablock (i.e.
void | setDatablockOrMaterialName (String materialName, String groupName)
| First tries to see if an HLMS datablock exist with the given name, if not, tries to search among low level materials.
virtual void | setMaterial (const MaterialPtr &material)
| Sets the given material. Overrides HLMS materials.
void | setMaterialName (const String &name, const String &groupName)
| Sets the name of the Material to be used. Prefer using HLMS.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setPoseWeight (size_t index, float w)
void | setRenderQueueSubGroup (uint8 subGroup)
| Sets the render queue sub group.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
virtual OGRE_DEPRECATED void | setUserAny (const Any &anything)

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Static Public Member Functions inherited from Ogre::Renderable
static uint8 | getDefaultRenderQueueSubGroup ()
static void | setDefaultRenderQueueSubGroup (uint8 subGroup)
| Sets the default render queue sub group for all future Renderable instances.
Public Attributes inherited from Ogre::Renderable
uint8 | mCustomParameter
uint32 | mHlmsGlobalIndex
| Index in the vector holding this Rendrable reference in the HLMS datablock.
bool | mRenderableVisible
| Control visibility at Renderable (e.g.

## Detailed Description

This class implements an overlay element which contains simple unformatted text.

## Member Enumeration Documentation

## ◆ Alignment

enum Ogre::v1::TextAreaOverlayElement::Alignment

Enumerator
Left |
Right |
Center |

## Constructor & Destructor Documentation

## ◆ TextAreaOverlayElement()

Ogre::v1::TextAreaOverlayElement::TextAreaOverlayElement | ( | const String & | name | ) |

Constructor.

## ◆ ~TextAreaOverlayElement()

Ogre::v1::TextAreaOverlayElement::~TextAreaOverlayElement | ( |  | ) |
| override

## Member Function Documentation

## ◆ _releaseManualHardwareResources()

void Ogre::v1::TextAreaOverlayElement::_releaseManualHardwareResources | ( |  | ) |
| overridevirtual

Notifies that hardware resources were lost.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ _restoreManualHardwareResources()

void Ogre::v1::TextAreaOverlayElement::_restoreManualHardwareResources | ( |  | ) |
| overridevirtual

Notifies that hardware resources should be restored.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ _update()

void Ogre::v1::TextAreaOverlayElement::_update | ( |  | ) |
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ getAlignment()

Alignment Ogre::v1::TextAreaOverlayElement::getAlignment | ( |  | ) | const
| inline

## ◆ getCharHeight()

Real Ogre::v1::TextAreaOverlayElement::getCharHeight | ( |  | ) | const

## ◆ getColour()

const ColourValue & Ogre::v1::TextAreaOverlayElement::getColour | ( |  | ) | const
| overridevirtual

Gets the colour of the text.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ getColourBottom()

const ColourValue & Ogre::v1::TextAreaOverlayElement::getColourBottom | ( |  | ) | const

Gets the colour of the bottom of the letters.

## ◆ getColourTop()

const ColourValue & Ogre::v1::TextAreaOverlayElement::getColourTop | ( |  | ) | const

Gets the colour of the top of the letters.

## ◆ getFontName()

const String & Ogre::v1::TextAreaOverlayElement::getFontName | ( |  | ) | const

## ◆ getMaterial()

const MaterialPtr & Ogre::v1::TextAreaOverlayElement::getMaterial | ( |  | ) | const

See Renderable.

## ◆ getRenderOperation()

void Ogre::v1::TextAreaOverlayElement::getRenderOperation | ( | v1::RenderOperation & | op,
|  | bool | casterPass )
| overridevirtual

See Renderable.

Implements Ogre::Renderable.

## ◆ getSpaceWidth()

Real Ogre::v1::TextAreaOverlayElement::getSpaceWidth | ( |  | ) | const

## ◆ getTypeName()

const String & Ogre::v1::TextAreaOverlayElement::getTypeName | ( |  | ) | const
| overridevirtual

See OverlayElement.

Implements Ogre::v1::OverlayElement.

## ◆ initialise()

void Ogre::v1::TextAreaOverlayElement::initialise | ( |  | ) |
| overridevirtual

Initialise gui element.

Implements Ogre::v1::OverlayElement.

## ◆ setAlignment()

void Ogre::v1::TextAreaOverlayElement::setAlignment | ( | Alignment | a | ) |
| inline

## ◆ setCaption()

void Ogre::v1::TextAreaOverlayElement::setCaption | ( | const DisplayString & | text | ) |
| overridevirtual

Sets the caption on elements that support it.

Remarks
  This property doesn't do something on all elements, just those that support it. However, being a common requirement it is in the top-level interface to avoid having to set it via the StringInterface all the time.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ setCharHeight()

void Ogre::v1::TextAreaOverlayElement::setCharHeight | ( | Real | height | ) |

## ◆ setColour()

void Ogre::v1::TextAreaOverlayElement::setColour | ( | const ColourValue & | col | ) |
| overridevirtual

Sets the colour of the text.

Remarks
  This method establishes a constant colour for the entire text. Also see setColourBottom and setColourTop which allow you to set a colour gradient.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ setColourBottom()

void Ogre::v1::TextAreaOverlayElement::setColourBottom | ( | const ColourValue & | col | ) |

Sets the colour of the bottom of the letters.

Remarks
  By setting a separate top and bottom colour, you can create a text area which has a graduated colour effect to it.

## ◆ setColourTop()

void Ogre::v1::TextAreaOverlayElement::setColourTop | ( | const ColourValue & | col | ) |

Sets the colour of the top of the letters.

Remarks
  By setting a separate top and bottom colour, you can create a text area which has a graduated colour effect to it.

## ◆ setFontName()

void Ogre::v1::TextAreaOverlayElement::setFontName | ( | const String & | font | ) |

## ◆ setMaterialName()

void Ogre::v1::TextAreaOverlayElement::setMaterialName | ( | const String & | matName | ) |
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ setMetricsMode()

void Ogre::v1::TextAreaOverlayElement::setMetricsMode | ( | GuiMetricsMode | gmm | ) |
| overridevirtual

Overridden from OverlayElement.

Reimplemented from Ogre::v1::OverlayElement.

## ◆ setSpaceWidth()

void Ogre::v1::TextAreaOverlayElement::setSpaceWidth | ( | Real | width | ) |

The documentation for this class was generated from the following file:

- OgreTextAreaOverlayElement.h